package com.qmth.paper.library.api;


import com.qmth.boot.api.annotation.Aac;
import com.qmth.boot.api.annotation.BOOL;
import com.qmth.boot.api.constant.ApiConstant;
import com.qmth.paper.library.business.service.ClientService;
import com.qmth.paper.library.common.contant.SystemConstant;
import com.qmth.paper.library.common.util.Result;
import com.qmth.paper.library.common.util.ResultUtil;
import io.swagger.annotations.*;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import javax.validation.constraints.Max;
import javax.validation.constraints.Min;

/**
 * <p>
 * 扫描端 前端控制器
 * </p>
 */
@Api(tags = "扫描端Controller")
@RestController
@RequestMapping(ApiConstant.DEFAULT_URI_PREFIX + "/${prefix.url.client}/scan")
@Validated
@Aac(strict = BOOL.FALSE, auth = BOOL.FALSE)
public class ClientController {

    @Resource
    private ClientService clientService;

    @ApiOperation(value = "任务查询")
    @PostMapping("/page")
    @ApiResponses({@ApiResponse(code = 200, message = "查询成功", response = Result.class)})
    public Result page(@ApiParam(value = "档案") @RequestParam(required = false) Long paperArchivesId,
                       @ApiParam(value = "课程") @RequestParam(required = false) String courseName,
                       @ApiParam(value = "班级") @RequestParam(required = false) String clazzName,
                       @ApiParam(value = "是否扫描") @RequestParam(required = false) Boolean isScan,
                       @ApiParam(value = "分页页码", required = true) @RequestParam @Min(SystemConstant.PAGE_NUMBER_MIN) Integer pageNumber,
                       @ApiParam(value = "分页数", required = true) @RequestParam @Min(SystemConstant.PAGE_SIZE_MIN) @Max(SystemConstant.PAGE_SIZE_MAX) Integer pageSize) {
        return ResultUtil.ok(clientService.pageScanTask(paperArchivesId, courseName, clazzName, isScan, pageNumber, pageSize));
    }

}
